module list_tools

    implicit none

!   double-linked list with a single real number as inner content
    type line_list
        real :: a
        type(line_list), pointer :: next
        type(line_list), pointer :: previous
    endtype line_list

end module list_tools


program list
! The program read a list of real numbers from a file list.dat
! The number of lines is unknown. A double linked list is used.

  use list_tools
! Declare head and current element list pointers
  type(line_list), pointer :: first=>null(), current=>null()
  integer :: i=0, ios=0

! Open the file
  open(25,FILE='list.dat')

! Allocate and initialize the head of the list "first"
  allocate(first) ; first%next => null(); first%previous => null()
  current => first

  print*,'Reading list...'
! Iterating over file lines
!--------------------------------------------
! ADD READ LOOP HERE
!--------------------------------------------

!--------------------------------------------
! DELETE THE LAST ELEMENT OF THE LIST 
!--------------------------------------------

! Close the file
  close(25)

  print*,'Checking list...'
! check the list content
  if(i==1) then
    print*,'Empty list'
  else
    i = 0
    current => first
    do while (associated(current))
       i = i+1
       print*,'line i: ',i,' value: ', current%a
       current => current%next
    end do
  endif

end program list
